• [LeetCode] 438. Find All Anagrams in a String 找出字符串中所有的变位词


    Given a string s and a non-empty string p, find all the start indices of p's anagrams in s.

    Strings consists of lowercase English letters only and the length of both strings s and p will not be larger than 20,100.

    The order of output does not matter.

    Example 1:

    Input:
    s: "cbaebabacd" p: "abc"
    
    Output:
    [0, 6]
    
    Explanation:
    The substring with start index = 0 is "cba", which is an anagram of "abc".
    The substring with start index = 6 is "bac", which is an anagram of "abc".
    

    Example 2:

    Input:
    s: "abab" p: "ab"
    
    Output:
    [0, 1, 2]
    
    Explanation:
    The substring with start index = 0 is "ab", which is an anagram of "ab".
    The substring with start index = 1 is "ba", which is an anagram of "ab".
    The substring with start index = 2 is "ab", which is an anagram of "ab".

    这道题给了我们两个字符串s和p,让在s中找字符串p的所有变位次的位置,所谓变位次就是字符种类个数均相同但是顺序可以不同的两个词,那么肯定首先就要统计字符串p中字符出现的次数,然后从s的开头开始,每次找p字符串长度个字符,来验证字符个数是否相同,如果不相同出现了直接 break,如果一直都相同了,则将起始位置加入结果 res 中,参见代码如下:

    解法一:

    class Solution {
    public:
        vector<int> findAnagrams(string s, string p) {
            if (s.empty()) return {};
            vector<int> res, cnt(128, 0);
            int ns = s.size(), np = p.size(), i = 0;
            for (char c : p) ++cnt[c];
            while (i < ns) {
                bool success = true;
                vector<int> tmp = cnt;
                for (int j = i; j < i + np; ++j) {
                    if (--tmp[s[j]] < 0) {
                        success = false;
                        break;
                    }
                }
                if (success) {
                    res.push_back(i); 
                }
                ++i;
            }
            return res;
        }
    };

    我们可以将上述代码写的更加简洁一些,用两个哈希表,分别记录p的字符个数,和s中前p字符串长度的字符个数,然后比较,如果两者相同,则将0加入结果 res 中,然后开始遍历s中剩余的字符,每次右边加入一个新的字符,然后去掉左边的一个旧的字符,每次再比较两个哈希表是否相同即可,参见代码如下:

    解法二:

    class Solution {
    public:
        vector<int> findAnagrams(string s, string p) {
            if (s.empty()) return {};
            vector<int> res, m1(256, 0), m2(256, 0);
            for (int i = 0; i < p.size(); ++i) {
                ++m1[s[i]]; ++m2[p[i]];
            }
            if (m1 == m2) res.push_back(0);
            for (int i = p.size(); i < s.size(); ++i) {
                ++m1[s[i]]; 
                --m1[s[i - p.size()]];
                if (m1 == m2) res.push_back(i - p.size() + 1);
            }
            return res;
        }
    };

    下面这种利用滑动窗口 Sliding Window 的方法也比较巧妙,首先统计字符串p的字符个数,然后用两个变量 left 和 right 表示滑动窗口的左右边界,用变量 cnt 表示字符串p中需要匹配的字符个数,然后开始循环,如果右边界的字符已经在哈希表中了,说明该字符在p中有出现,则 cnt 自减1,然后哈希表中该字符个数自减1,右边界自加1,如果此时 cnt 减为0了,说明p中的字符都匹配上了,那么将此时左边界加入结果 res 中。如果此时 right 和 left 的差为p的长度,说明此时应该去掉最左边的一个字符,如果该字符在哈希表中的个数大于等于0,说明该字符是p中的字符,为啥呢,因为上面有让每个字符自减1,如果不是p中的字符,那么在哈希表中个数应该为0,自减1后就为 -1,所以这样就知道该字符是否属于p,如果去掉了属于p的一个字符,cnt 自增1,参见代码如下:

    解法三:

    class Solution {
    public:
        vector<int> findAnagrams(string s, string p) {
            if (s.empty()) return {};
            vector<int> res, m(256, 0);
            int left = 0, right = 0, cnt = p.size(), n = s.size();
            for (char c : p) ++m[c];
            while (right < n) {
                if (m[s[right++]]-- >= 1) --cnt;
                if (cnt == 0) res.push_back(left);
                if (right - left == p.size() && m[s[left++]]++ >= 0) ++cnt;
            }
            return res;
        }
    };

    Github 同步地址:

    https://github.com/grandyang/leetcode/issues/438

    类似题目:

    Valid Anagram

    Anagrams

    参考资料:

    https://leetcode.com/problems/find-all-anagrams-in-a-string/

    https://leetcode.com/problems/find-all-anagrams-in-a-string/discuss/92015/ShortestConcise-JAVA-O(n)-Sliding-Window-Solution

    https://leetcode.com/problems/find-all-anagrams-in-a-string/discuss/92027/c-on-sliding-window-concise-solution-with-explanation

    https://leetcode.com/problems/find-all-anagrams-in-a-string/discuss/92007/Sliding-Window-algorithm-template-to-solve-all-the-Leetcode-substring-search-problem.

    LeetCode All in One 题目讲解汇总(持续更新中...)

  • 相关阅读:
    ubuntu下使用ppa安装codeblocks集成开发环境
    CentOS g++ 安装
    CentOS 7.1云服务器 配置FTP服务器vsftpd
    div高度自适应浏览器高度
    HTML中的head结构
    javascript高级进阶系列
    javascript集中跨域方法
    canvas标签的width和height以及style.width和style.height的区别
    html5学习笔记之入新特性
    ie下a标签里的图片会有边框
  • 原文地址:https://www.cnblogs.com/grandyang/p/6014408.html
Copyright © 2020-2023  润新知